diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index ed0ed089b..d71dc23ee 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -1352,30 +1381,30 @@ public class Minecraft
         }
         Debug.change("textureTick");
         TextureRegistry.blockAtlas.bind();
-        renderEngine.updateDynamicTextures(isGamePaused);
+        textureManager.updateDynamicTextures(isGamePaused);
         Debug.change("misc");
         if(currentScreen == null && thePlayer != null)
         {
             if(thePlayer.getHealth() <= 0)
             {
-                displayGuiScreen(null);
+                displayScreen(null);
             }
             else if(thePlayer.isPlayerSleeping() && theWorld != null)
             {
                 if(theWorld.isClientSide)
                 {
-                    displayGuiScreen(new GuiSleepMP());
+                    displayScreen(new SleepScreenMP());
                 }
                 else
                 {
-                    displayGuiScreen(new GuiSleepSP());
+                    displayScreen(new SleepScreenSP());
                 }
                 
             }
         }
-        else if(currentScreen != null && (currentScreen instanceof GuiSleepMP) && !thePlayer.isPlayerSleeping())
+        else if(currentScreen != null && (currentScreen instanceof SleepScreenMP) && !thePlayer.isPlayerSleeping())
         {
-            displayGuiScreen(null);
+            displayScreen(null);
         }
         Debug.change("input");
         if(currentScreen != null)
@@ -1393,13 +1422,13 @@ public class Minecraft
 
         if (currentScreen != null)
         {
-            currentScreen.handleInput();
+            currentScreen.updateEvents();
             if (currentScreen != null)
             {
                 currentScreen.tick();
             }
         }
-        if (currentScreen == null || currentScreen.allowIngameInput)
+        if (currentScreen == null || currentScreen.passEvents)
         {
             while (Mouse.next())
             {
@@ -1421,7 +1450,7 @@ public class Minecraft
                         	gameSettings.flightSpeed.value = newSpeed;
                         	
                         	thePlayer.setFlySpeed(newSpeed);
-                        	ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.flightSpeed);
+                        	ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.flightSpeed);
                         }
                         else if (!gameSettings.keyZoom.isPressed())
                         {
@@ -1494,13 +1523,13 @@ public class Minecraft
                         if (gameSettings.keyToggleDebug.isPressed())
                         {
                             if(Keyboard.getEventKey() == Keyboard.KEY_Q) {
-                                ingameGUI.addChatMessage(TextFormatting.YELLOW + "Keyboard shortcuts: ");
+                                ingameHud.addChatMessage(TextFormatting.YELLOW + "Keyboard shortcuts: ");
                                 gameSettings.debugsKeys.sort(Comparator.comparing(KeyBinding::getKeyName));
                                 for (KeyBinding binding: gameSettings.debugsKeys){
-                                    ingameGUI.addChatMessage(String.format("%s + %s: %s", gameSettings.keyToggleDebug.getKeyName(), binding.getKeyName(), I18n.getInstance().translateKey(binding.getId())));
+                                    ingameHud.addChatMessage(String.format("%s + %s: %s", gameSettings.keyToggleDebug.getKeyName(), binding.getKeyName(), I18n.getInstance().translateKey(binding.getId())));
                                 }
-                                ingameGUI.addChatMessage(String.format("%s: %s", gameSettings.keyToggleTextureAtlas.getKeyName(), I18n.getInstance().translateKey(gameSettings.keyToggleTextureAtlas.getId())));
-                                ingameGUI.addChatMessage(String.format("%s: %s", gameSettings.keyReleaseCursor.getKeyName(), I18n.getInstance().translateKey(gameSettings.keyReleaseCursor.getId())));
+                                ingameHud.addChatMessage(String.format("%s: %s", gameSettings.keyToggleTextureAtlas.getKeyName(), I18n.getInstance().translateKey(gameSettings.keyToggleTextureAtlas.getId())));
+                                ingameHud.addChatMessage(String.format("%s: %s", gameSettings.keyReleaseCursor.getKeyName(), I18n.getInstance().translateKey(gameSettings.keyReleaseCursor.getId())));
                             }
                             if (gameSettings.keyReload.isPressEvent())
                             {
@@ -1549,43 +1578,43 @@ public class Minecraft
                                         }
                                     }
                                 }
-                                ingameGUI.guiHeldItemTooltip.setString("Fullbright: " + (fullbright ? "On" : "Off"));
+                                ingameHud.heldItemTooltipElement.setString("Fullbright: " + (fullbright ? "On" : "Off"));
                             }
                             else if (gameSettings.keyLightmaps.isPressEvent())
                             {
                             	if(gameSettings.lightmapStyle.value == LightmapStyle.DISABLED) {
                             		gameSettings.lightmapStyle.value = LightmapStyle.GRAY;
-                            		ingameGUI.guiHeldItemTooltip.setString("Lightmap: On");
+                            		ingameHud.heldItemTooltipElement.setString("Lightmap: On");
                             		renderGlobal.loadRenderers();
                             	}else {
                             		gameSettings.lightmapStyle.value = LightmapStyle.DISABLED;
-                            		ingameGUI.guiHeldItemTooltip.setString("Lightmap: Off");
+                            		ingameHud.heldItemTooltipElement.setString("Lightmap: Off");
                             		renderGlobal.loadRenderers();
                             	}
                             }
                             else if (gameSettings.keyCollisionBoxes.isPressEvent())
                             {
                             	gameSettings.showCollisionBoxes.toggle();
-                                ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.showCollisionBoxes);
+                                ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.showCollisionBoxes);
                             }
                             else if (gameSettings.keyChunkBorders.isPressEvent())
                             {
                             	gameSettings.showChunkBorders.toggle();
-                                ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.showChunkBorders);
+                                ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.showChunkBorders);
                             }
                             else if (gameSettings.keyClearChat.isPressEvent())
                             {
-                                ingameGUI.clearChatMessages();
+                                ingameHud.clearChatMessages();
                             }
                             else if (gameSettings.keyPauseLostFocus.isPressEvent())
                             {
                                 gameSettings.pauseOnLostFocus.toggle();
-                                ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.pauseOnLostFocus);
+                                ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.pauseOnLostFocus);
                             }
                             else if (gameSettings.keyToggleItemInfo.isPressEvent())
                             {
                                 gameSettings.showItemDebugInfo.toggle();
-                                ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.showItemDebugInfo);
+                                ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.showItemDebugInfo);
                             }
                             else if (gameSettings.keyReloadChunks.isPressEvent())
                             {
@@ -1595,7 +1624,7 @@ public class Minecraft
                             {
                                 gameSettings.ambientOcclusion.toggle();
                                 gameSettings.ambientOcclusion.onUpdate();
-                                ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.ambientOcclusion);
+                                ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.ambientOcclusion);
                             }
                             if(!gameSettings.keyToggleDebug.isPressEvent()) f3Press = false;
                         }
@@ -1609,7 +1638,7 @@ public class Minecraft
                         }
                         else if (gameSettings.keyCommand.isPressed())
                         {
-                            displayGuiScreen(new GuiChat("/"));
+                            displayScreen(new ChatScreen("/"));
                         }
                         else
                         {
@@ -1684,7 +1713,7 @@ public class Minecraft
             if(!isGamePaused)
             {
                 Debug.change("effects");
-                effectRenderer.updateEffects();
+                particleEngine.tick();
                 Debug.change("misc");
             }
         }
@@ -1750,20 +1779,20 @@ public class Minecraft
         // Cinematic camera
         if (gameSettings.keyCinematicCamera.isPressEvent(currentInputDevice)) {
             gameSettings.smoothCamera.value = !gameSettings.smoothCamera.value;
-            ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.smoothCamera);
+            ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.smoothCamera);
             return true;
         }
 
         // Display inventory
         if (gameSettings.keyInventory.isPressEvent(currentInputDevice)) {
-            displayGuiScreen(getGuiInventory());
+            displayScreen(getInventoryScreen());
             return true;
         }
 
         // Display Guidebook
         if (gameSettings.keyGuidebook.isPressEvent(currentInputDevice)) {
             thePlayer.triggerAchievement(Achievements.OPEN_GUIDEBOOK);
-            thePlayer.displayGUIGuidebook();
+            thePlayer.displayGuidebookScreen();
             return true;
         }
 
@@ -1775,13 +1804,13 @@ public class Minecraft
 
         // Enter photo mode
         if (gameSettings.keyPhotoMode.isPressEvent(currentInputDevice)) {
-            displayGuiScreen(new GuiPhotoMode());
+            displayScreen(new PhotoModeScreen());
             return true;
         }
 
         // Open chat
         if (gameSettings.keyChat.isPressEvent(currentInputDevice)) {
-            displayGuiScreen(new GuiChat());
+            displayScreen(new ChatScreen());
             return true;
         }
 
@@ -1846,7 +1875,7 @@ public class Minecraft
         // Toggle fog
         if (gameSettings.keyToggleFog.isPressEvent(currentInputDevice)) {
             gameSettings.renderDistance.toggle(shift ? -8 : 8);
-            ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.renderDistance);
+            ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.renderDistance);
             return true;
         }
 
@@ -1864,7 +1893,7 @@ public class Minecraft
             }
             int newGammaStep = ((currentGammaStep + (shift ? -1 : 1)) + 5) % 5;
             gameSettings.gamma.value = newGammaStep * 0.25f;
-            ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.gamma);
+            ingameHud.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.gamma);
             return true;
         }
 
@@ -1913,15 +1942,15 @@ public class Minecraft
         return false;
     }
 
-    private GuiInventory getGuiInventory()
+    private InventoryScreen getInventoryScreen()
     {
         if (thePlayer.getGamemode() == Gamemode.creative)
         {
-            return new GuiInventoryCreative(thePlayer);
+            return new InventoryScreenCreative(thePlayer);
         }
         else
         {
-            return new GuiInventory(thePlayer);
+            return new InventoryScreen(thePlayer);
         }
     }
     
@@ -1929,7 +1958,7 @@ public class Minecraft
         try{
             controllerInput.update();
         }catch (Exception e) {
-            e.printStackTrace();
+            LOGGER.warn("Error occurred while updating controller input! Disabling controller input!", e);
             controllerInput = null;
             setInputType(InputType.KEYBOARD);
             return;
@@ -1957,13 +1986,13 @@ public class Minecraft
                 thePlayer.dropCurrentItem(false);
             }
             if(controller.buttonY.pressedThisFrame() || controller.buttonX.pressedThisFrame()) {
-                displayGuiScreen(getGuiInventory());
+                displayScreen(getInventoryScreen());
             }
             if(controller.buttonBack.pressedThisFrame()) {
                 gameSettings.showPlayerList.value = !gameSettings.showPlayerList.value;
             }
             if(controller.buttonStart.pressedThisFrame()) {
-                displayGuiScreen(new GuiIngameMenu());
+                displayScreen(new PauseScreen());
             }
             if(controller.digitalPad.up.pressedThisFrame()) {
                 thePlayer.setHotbarOffset((thePlayer.inventory.hotbarOffset + 27) % (36));
@@ -1989,27 +2018,27 @@ public class Minecraft
                 gameSettings.thirdPersonView.value%=3;
             }
             if (controllerInput.digitalPad.right.pressedThisFrame()){
-                thePlayer.displayGUIGuidebook();
+                thePlayer.displayGuidebookScreen();
             }
         }else {
-            GuiScreen currentScreen = this.currentScreen;
+            Screen currentScreen = this.currentScreen;
             if(controller.buttonB.pressedThisFrame()) {
-                currentScreen.keyTyped((char)0, Keyboard.KEY_BACK, -1, -1);
+                currentScreen.keyPressed((char)0, Keyboard.KEY_BACK, -1, -1);
             }
             if(controller.buttonStart.pressedThisFrame()) {
-                currentScreen.keyTyped((char)0, Keyboard.KEY_ESCAPE, -1, -1);
+                currentScreen.keyPressed((char)0, Keyboard.KEY_ESCAPE, -1, -1);
             }
             if(controller.buttonA.pressedThisFrame()) {
                 currentScreen.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 0);
             }
             if(controller.buttonA.releasedThisFrame()) {
-                currentScreen.mouseMovedOrButtonReleased((int)controller.cursorX, (int)controller.cursorY, 0);
+                currentScreen.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 0);
             }
             if(controller.buttonY.pressedThisFrame()) {
                 currentScreen.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 1);
             }
             if(controller.buttonY.releasedThisFrame()) {
-                currentScreen.mouseMovedOrButtonReleased((int)controller.cursorX, (int)controller.cursorY, 1);
+                currentScreen.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 1);
             }
             if(controller.buttonX.pressedThisFrame()) {
                 currentScreen.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 10);
@@ -2019,7 +2048,7 @@ public class Minecraft
             try{
                 currentScreen.controllerInput(controller);
             }catch (Exception e) {
-                e.printStackTrace();
+                LOGGER.error("Exception occurred while running gui specific controller actions!", e);
             }
         }
     }
@@ -2027,7 +2056,7 @@ public class Minecraft
     private void forceReload()
     {
         long start = System.nanoTime();
-        System.out.println("FORCING RELOAD!");
+        LOGGER.info("FORCING RELOAD!");
         sndManager = new SoundEngine();
         sndManager.init(gameSettings);
         texturePackList.refresh();
@@ -2035,7 +2064,7 @@ public class Minecraft
         if (renderGlobal != null){
             renderGlobal.loadRenderers();
         }
-        System.out.println("RELOAD TOOK '" + (System.nanoTime() - start)/ 1_000_000_000d + "' SECONDS!");
+        LOGGER.debug("RELOAD TOOK '{}' SECONDS!", (System.nanoTime() - start) / 1_000_000_000d);
     }
 
     public boolean isMultiplayerWorld()
@@ -2106,7 +2135,7 @@ public class Minecraft
     {
         Dimension lastDim = Dimension.getDimensionList().get(thePlayer.dimension);
         Dimension newDim = Dimension.getDimensionList().get(dim);
-        System.out.println("Switching to dimension \"" + newDim.getTranslatedName() + "\"!!");
+        LOGGER.info("Switching to dimension \"{}\"!!", newDim.getTranslatedName());
         thePlayer.dimension = dim;
         theWorld.setEntityDead(thePlayer);
         thePlayer.removed = false;
@@ -2210,10 +2239,7 @@ public class Minecraft
             else if(thePlayer != null)
             {
                 thePlayer.resetPos();
-                if(world != null)
-                {
-                    world.entityJoinedWorld(thePlayer);
-                }
+                world.entityJoinedWorld(thePlayer);
             }
             if(!world.isClientSide)
             {
@@ -2230,9 +2256,9 @@ public class Minecraft
             {
                 renderGlobal.changeWorld(world);
             }
-            if(effectRenderer != null)
+            if(particleEngine != null)
             {
-                effectRenderer.clearEffects(world);
+                particleEngine.setWorld(world);
             }
             playerController.adjustPlayer(thePlayer);
             IChunkProvider ichunkprovider = world.getChunkProvider();
@@ -2366,7 +2392,7 @@ public class Minecraft
     
     public String getEntityCountsInfoString()
     {
-        return "P: " + effectRenderer.getNumParticlesString() + ". T: " + theWorld.getNumLoadedEntitiesString();
+        return "P: " + particleEngine.countParticles() + ". T: " + theWorld.getNumLoadedEntitiesString();
     }
 
     public void respawn(boolean flag, int i)
@@ -2438,12 +2464,12 @@ public class Minecraft
         theWorld.spawnPlayerWithLoadedChunks(thePlayer);
         thePlayer.input = new PlayerInput(this);
         thePlayer.id = j;
-        thePlayer.func_6420_o();
+        thePlayer.animate4();
         playerController.adjustPlayer(thePlayer);
         prepareLevel("Respawning");
-        if(currentScreen instanceof GuiGameOver)
+        if(currentScreen instanceof GameOverScreen)
         {
-            displayGuiScreen(null);
+            displayScreen(null);
         }
     }
 
@@ -2466,47 +2492,92 @@ public class Minecraft
         this.renderer.reload();
     }
 
-    public static void startMainThread(String username, String sessionId)
+    public static void startMainThread(String username, String sessionId, String uuid)
     {
-        boolean flag = false;
-        String sessionUsername = username;
         GameWindow gameWindow = new GameWindowGLFW();
         Minecraft mc = new Minecraft(gameWindow);
         Thread thread = new Thread(mc, "Client-Main");
         thread.setPriority(10);
         mc.minecraftUri = "www.minecraft.net";
-        if(sessionUsername != null && sessionId != null)
-        {
-            mc.session = new Session(sessionUsername, sessionId);
-        }
-        else
-        {
-            mc.session = new Session("Player" + System.currentTimeMillis() % 1000L, "");
+
+        sessionId = sessionId == null ? "" : sessionId;
+        if (uuid == null) {
+            if (username != null) {
+                UUID nameUUID = UUIDHelper.getUUIDFromName(username);
+                if (nameUUID != null) {
+                    uuid = nameUUID.toString();
+                }
+            }
+            if (uuid == null) {
+                uuid = "00000000-0000-0000-0000-000000000000";
+            }
         }
+        username = username == null ? "Player" + System.currentTimeMillis() % 1000L : username;
+
+        mc.session = new Session(username, uuid, sessionId);
         thread.start();
     }
 
     public static void main(String[] args)
     {
-
         String playerName = null;
         String sessionId = null;
-        playerName = "Player" + System.currentTimeMillis() % 1000L;
-        if(args.length > 0)
-        {
-            playerName = args[0];
-        }
-        sessionId = "-";
-        if(args.length > 1)
-        {
-            sessionId = args[1];
+        String gameDirectory = null;
+        String uuid = null;
+
+        int pointer = 0;
+        while (pointer < args.length) {
+            switch (args[pointer]) {
+                case "--username": {
+                    try {
+                        playerName = args[pointer + 1];
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                case "--session": {
+                    try {
+                        sessionId = args[pointer + 1];
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                case "--uuid": {
+                    try {
+                        uuid = args[pointer + 1];
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                case "--gameDir": {
+                    try {
+                        gameDirectory = args[pointer + 1];
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                default:
+                    pointer++;
+            }
         }
-        startMainThread(playerName, sessionId);
+        startMainThread(playerName, sessionId, uuid);
     }
     
     public void setInputType(InputType inputType) {
         if(inputType != this.inputType) {
-            System.out.println("Set input type to "+inputType.name());
+            LOGGER.info("Set input type to {}", inputType.name());
         }
         this.inputType = inputType;
         if(inputType == InputType.CONTROLLER) {
@@ -2576,8 +2647,4 @@ public class Minecraft
         }
         return INSTANCE;
     }
-    
-    public static void crash() {
-    	throw new RuntimeException("lol");
-    }
 }
diff --git a/src/main/java/net/minecraft/client/discord/DownloadNativeLibrary.java b/src/main/java/net/minecraft/client/discord/DownloadNativeLibrary.java
index ea6fac289..bbce60cc5 100644
--- a/src/main/java/net/minecraft/client/discord/DownloadNativeLibrary.java
+++ b/src/main/java/net/minecraft/client/discord/DownloadNativeLibrary.java
@@ -1,8 +1,5 @@
 package net.minecraft.client.discord;
 
-import de.jcm.discordgamesdk.Core;
-import de.jcm.discordgamesdk.CreateParams;
-
 import java.io.File;
 import java.io.IOException;
 import java.net.HttpURLConnection;
@@ -12,14 +9,8 @@ import java.util.Locale;
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipInputStream;
 
-/**
- * An examples showing how to automatically download, extract and load
- * Discord's native library.
- */
-public class DownloadNativeLibrary
-{
-    public static File downloadDiscordLibrary() throws IOException
-    {
+public class DownloadNativeLibrary {
+    public static File downloadDiscordLibrary() throws IOException {
         // Find out which name Discord's library has (.dll for Windows, .so for Linux)
         String name = "discord_game_sdk";
         String suffix;
@@ -27,32 +18,25 @@ public class DownloadNativeLibrary
         String osName = System.getProperty("os.name").toLowerCase(Locale.ROOT);
         String arch = System.getProperty("os.arch").toLowerCase(Locale.ROOT);
 
-        if(osName.contains("windows"))
-        {
+        if (osName.contains("windows")) {
             suffix = ".dll";
-        }
-        else if(osName.contains("linux"))
-        {
+        } else if (osName.contains("linux")) {
             suffix = ".so";
-        }
-        else if(osName.contains("mac os"))
-        {
+        } else if (osName.contains("mac os")) {
             suffix = ".dylib";
-        }
-        else
-        {
-            throw new RuntimeException("cannot determine OS type: "+osName);
+        } else {
+            throw new RuntimeException("cannot determine OS type: " + osName);
         }
 
 		/*
 		Some systems report "amd64" (e.g. Windows and Linux), some "x86_64" (e.g. Mac OS).
 		At this point we need the "x86_64" version, as this one is used in the ZIP.
 		 */
-        if(arch.equals("amd64"))
+        if (arch.equals("amd64"))
             arch = "x86_64";
 
         // Path of Discord's library inside the ZIP
-        String zipPath = "lib/"+arch+"/"+name+suffix;
+        String zipPath = "lib/" + arch + "/" + name + suffix;
 
         // Open the URL as a ZipInputStream
         URL downloadUrl = new URL("https://dl-game-sdk.discordapp.net/2.5.6/discord_game_sdk.zip");
@@ -62,19 +46,17 @@ public class DownloadNativeLibrary
 
         // Search for the right file inside the ZIP
         ZipEntry entry;
-        while((entry = zin.getNextEntry())!=null)
-        {
-            if(entry.getName().equals(zipPath))
-            {
+        while ((entry = zin.getNextEntry()) != null) {
+            if (entry.getName().equals(zipPath)) {
                 // Create a new temporary directory
                 // We need to do this, because we may not change the filename on Windows
-                File tempDir = new File(System.getProperty("java.io.tmpdir"), "java-"+name+System.nanoTime());
-                if(!tempDir.mkdir())
+                File tempDir = new File(System.getProperty("java.io.tmpdir"), "java-" + name + System.nanoTime());
+                if (!tempDir.mkdir())
                     throw new IOException("Cannot create temporary directory");
                 tempDir.deleteOnExit();
 
                 // Create a temporary file inside our directory (with a "normal" name)
-                File temp = new File(tempDir, name+suffix);
+                File temp = new File(tempDir, name + suffix);
                 temp.deleteOnExit();
 
                 // Copy the file in the ZIP to our temporary file
